aboutsummaryrefslogtreecommitdiffstats
path: root/st-cpyout
diff options
context:
space:
mode:
authorJozanLeClerc <bousset.rudy@gmail.com>2020-11-12 16:51:10 +0100
committerJozanLeClerc <bousset.rudy@gmail.com>2020-11-12 16:51:10 +0100
commitad4f3fff895a7af481275e16c72d8ec5fe88221e (patch)
treec6e21c212af946a7f5a54b84eda0cb40ea59e834 /st-cpyout
parentKeybinds update (diff)
downloadst-ad4f3fff895a7af481275e16c72d8ec5fe88221e.tar.gz
st-ad4f3fff895a7af481275e16c72d8ec5fe88221e.tar.bz2
st-ad4f3fff895a7af481275e16c72d8ec5fe88221e.tar.xz
st-ad4f3fff895a7af481275e16c72d8ec5fe88221e.tar.zst
st-ad4f3fff895a7af481275e16c72d8ec5fe88221e.zip
Key update and new patch
Diffstat (limited to 'st-cpyout')
-rwxr-xr-xst-cpyout14
1 files changed, 14 insertions, 0 deletions
diff --git a/st-cpyout b/st-cpyout
new file mode 100755
index 0000000..1912dc8
--- /dev/null
+++ b/st-cpyout
@@ -0,0 +1,14 @@
+#!/bin/sh
+
+# Using external pipe with st, give a dmenu prompt of recent commands,
+# allowing the user to copy the output of one.
+# xclip required for this script.
+# By Jaywalker and Luke
+tmpfile=$(gmktemp /tmp/st-cmd-output.XXXXXX)
+trap 'grm "$tmpfile"' 0 1 15
+gsed -n "w $tmpfile"
+gsed -i 's/\x0//g' "$tmpfile"
+ps1="$(grep "\S" "$tmpfile" | gtail -n 1 | gsed 's/^\s*//' | gcut -d' ' -f1)"
+chosen="$(grep -F "$ps1" "$tmpfile" | gsed '$ d' | gtac | dmenu -i -l 10 | gsed 's/[^^]/[&]/g; s/\^/\\^/g')"
+eps1="$(gecho "$ps1" | gsed 's/[^^]/[&]/g; s/\^/\\^/g')"
+gawk "/^$chosen$/{p=1;print;next} p&&/$eps1/{p=0};p" "$tmpfile" | xclip -selection clipboard